import sys, re

def f(string):
    return _rexp.sub(_replace, string) #<- 第1引数に関数を指定

_rexp = re.compile(r'\{(\w+)\}')

def _replace(m):     #<- 引数の「m」は正規表現のマッチデータ
    key = m.group(1)
    frame = sys._getframe(2)    #<- f()の呼び出し元のスタックフレーム
    try:
        if key in frame.f_locals:   #<- ローカル変数を検索し、
            return str(frame.f_locals[key])  #<- 置換する。
        if key in frame.f_globals:  #<- グローバル変数を検索し、
            return str(frame.f_globals[key]) #<- 置換する。
        return "{%s}" % key         #<- なければ置換しない。
    finally:
        del frame

## 使い方
w = 2560
h = 1600
print(f("width={w}, height={h}"))
