import sys

def getter(func):
    return property(func)        #<- 「@property」と実質同じ

def setter(func):
    name = func.__name__         #<- 関数名
    vars = sys._getframe(1).f_locals #<- 呼び出し元（クラス定義）のローカル変数の一覧（辞書）
    prop = vars[name]            #<- getterで定義したプロパティ
    return prop.setter(func)     #<- 「@prop.setter」と実質同じ

## 使用例

class Movie(object):

    def __init__(self, title):
        self._title = title

    @getter          #<- タイトルのgetterを定義
    def title(self):
        return self._title

    @setter          #<- タイトルのsetterを定義
    def title(self, newtitle):
        self._title = newtitle

katasumi = Movie(u"この世界の片隅に")
print(katasumi.title)    #=> この世界の片隅に
katasumi.title = u"この世界の（さらにいくつもの）片隅に"
print(katasumi.title)    #=> この世界の（さらにいくつもの）片隅に
