import sys

def getter(func):
    name = func.__name__          #<- 関数名
    vars = sys._getframe(1).f_locals #<- 呼び出し元（クラス定義）のローカル変数の一覧（辞書）
    prop = vars.get(name, None)   #<- 定義済みのプロパティ
    if prop is None:              #<- 定義済みのプロパティがなければ
        return property(func)     #<-     「@property」と実質同じ
    return prop.getter(func)      #<- 「@prop.getter」と実質同じ

def setter(func):
    name = func.__name__          #<- 関数名
    vars = sys._getframe(1).f_locals #<- 呼び出し元（クラス定義）のローカル変数の一覧（辞書）
    prop = vars.get(name, None)   #<- 定義済みのプロパティ
    if prop is None:              #<- 定義済みのプロパティがなければ
        return property(None, func)  #<- setterだけを持つプロパティを生成
    return prop.setter(func)      #<- 「@prop.setter」と実質同じ

## 使用例（getterよりsetterを先に定義）

class Movie(object):

    def __init__(self, title):
        self._title = title

    @setter          #<- setterを先に定義してみる
    def title(self, newtitle):
        self._title = newtitle

    @getter          #<- getterを後から定義してみる
    def title(self):
        return self._title

katasumi = Movie(u"この世界の片隅に")
print(katasumi.title)    #=> この世界の片隅に
katasumi.title = u"この世界の（さらにいくつもの）片隅に"
print(katasumi.title)    #=> この世界の（さらにいくつもの）片隅に
