class AutoDict(dict):

    ## dict[key]を上書きする
    def __getitem__(self, key):
        if key not in self:         #<- キーがないときは
            self[key] = AutoDict()  #<- 空のAutoDictを設定する
            #self[key] = self.__class__()  #<- または継承を考慮した場合
        return super().__getitem__(key)  #<- 親クラスのメソッド
        #return self[key]     #<- これだとスタックオーバフローが発生

## 使い方
config = AutoDict()
config["user"]["name"]  = "Foo"            #<- エラーにならない
config["user"]["email"] = "foo@gmail.com"  #<- エラーにならない
print(config)   #=> {'user': {'name': 'Foo', 'email': 'foo@gmail.com'}}
