class HtmlElement:    #<- HTML要素を表すクラス

    def __init__(self, tagname, attrs={}, children=[]):
        self.tagname  = tagname        #<- タグ名
        self.attrs    = attrs          #<- 属性（辞書）
        self.children = children       #<- 子要素（リスト）

## 使い方：次のようなHTMLを考える
##   <div id="hello">
##     Hello, <span class="name">World</span>!
##   </div>
children = [
    "Hello, ",
    HtmlElement('span', {'class': 'name'}, ["World"]),
    "!",
]
div = HtmlElement('div', {'id': 'hello'}, children)
print(div.tagname)                    #=> div
print(div.attrs['id'])                #=> hello
print(div.children[1].tagname)        #=> span
print(div.children[1].attrs['class']) #=> name
