class HtmlElement:    #<- HTML要素を表すクラス

    def __init__(self, tagname, attrs={}, children=[]):
        self.tagname  = tagname        #<- タグ名
        self.attrs    = attrs          #<- 属性（辞書）
        self.children = children       #<- 子要素（リスト）

    def __getitem__(self, key):        #<- '[]' 演算子を上書き
        if isinstance(key, str):       #<- キーが文字列なら
            return self.attrs[key]     #<-   属性値を返す
        if isinstance(key, int):       #<- キーが整数なら
            return self.children[key]  #<-   子要素を返す
        raise KeyError(key)            #<- それ以外ならエラー

    def __getattr__(self, name):       #<- 属性へのアクセスを上書き
        try:
            return self.attrs[name]    #<- 属性値を返す
        except KeyError:               #<- もし属性がなければ
            pass                       #<-   KeyErrorではなく
        raise AttributeError(name)     #<-   AttributeErrorを発生

## 使い方
children = [
    "Hello, ",
    HtmlElement('span', {'class': 'name'}, ["World"]),
    "!",
]
div = HtmlElement('div', {'id': 'hello'}, children)
print(div.tagname)                    #=> div
print(div['id'])                      #=> hello
print(div.id)                         #=> hello
print(div[1].tagname)                 #=> span
print(div[1]['class'])                #=> name
print(div[1].className)               #=> AttributeError
