class Soldier(object):

    def __init__(self, name, height):
        self.name   = name
        self.height = height

    def __getitem__(self, key):         #<- obj[key] に相当
        if not hasattr(self, key):
            raise KeyError(key)
        return getattr(self, key)

    def __setitem__(self, key, value):  #<- obj[key] = value 相当
        if not hasattr(self, key):
            raise KeyError(key)
        setattr(self, key, value)

    def __delitem__(self, key):         #<- del obj[key] に相当
        if not hasattr(self, key):
            raise KeyError(key)
        delattr(self, key)

## 使用例
eren = Soldier(u"エレン", 170)
print(eren.name)               #=> エレン
print(eren['name'])            #=> エレン
eren['name'] = u"Eren Yeager"
print(eren.name)               #=> Eren Yeager
print(eren['name'])            #=> Eren Yeager
del eren['name']
print(eren.name)
   #=> AttributeError: 'Soldier' object has no attribute 'name'
