class DictObject(dict):     #<- 辞書クラス(dict)を継承する

    def __getattr__(self, name):
        return self[name]
        ### または
        #try:
        #    return self[name]
        #except KeyError:
        #    raise NameError(f"'dict' object has no key 'name'")

    def __setattr__(self, name, value):
        self[name] = value

    def __delattr__(self, name):
        del self[name]

## 使い方
x = DictObject({"name": u"ミカサ", "height": 170})
print(x['name'])         #=> ミカサ
print(x.name)            #=> ミカサ

x.name = "Mikasa Ackerman"
print(x['name'])         #=> Mikasa Ackerman
print(x.name)            #=> Mikasa Ackerman

print(list(x.keys()))    #=> ['name', 'height']
del x.name
print(list(x.keys()))    #=> ['height']
print(x.name)            #=> KeyError: 'name'
