class Dummy(object):

    def __init__(self, **vars):
        self._vars = vars      #<- __setattr__()が呼び出される

    def __setattr__(self, name, value):
        if name == '_vars':
            ## 親クラスの__setattr__()を呼び出す
            super().__setattr__(name, value)
        else:
            self._vars[name] = value

obj = Dummy(x=10, y=20)
obj.z = 30
print(obj._vars)     #=> {'x': 10, 'y': 20, 'z': 30}
