def assert_(actual):                 #<- ヘルパー関数は
    return AssertionObject(actual)   #<- ヘルパーオブジェクトを返す


class AssertionObject(object):       #<- ヘルパークラス

    def __init__(self, actual):      #<- 実際の値を指定
        self._actual = actual

    def __eq__(self, expected):      #<- 「==」の特殊メソッド
        actual = self._actual
        assert actual == expected, \
               "%r == %r" % (actual, expected)  #<- エラーメッセージ

    def __lt__(self, expected):      #<- 「<」の特殊メソッド
        actual = self._actual
        assert actual < expected, \
               "%r < %r" % (actual, expected)  #<- エラーメッセージ

## 使い方
def add(x, y):          #<- テスト対象
    #return x + y       #<- 正しいコードはこうだけど、
    return x * y        #<- ここではわざと間違ってみる

def test1():            #<- テスト関数
    actual = add(1, 1)  #<- 実際の値
    expected = 2        #<- 期待する値
    assert_(actual) < expected

test1()                 #<- テスト用関数を実行
