from datetime import date, timedelta

class Date(date):

    def __add__(self, delta):     #<- 「+」演算子の挙動を上書き
        if isinstance(delta, int):         #<- 引数が整数なら
            delta = timedelta(days=delta)  #<- timedelta型に変換
        ## 親クラスのメソッドを呼び出すだけだとdate型になる
        x = date.__add__(self, delta)
        #print(type(x))          #=> <class 'datetime.date'>
        ## なので、Date型に変換する
        return Date(x.year, x.month, x.day)

## 使い方（date型ではなくDate型になっていることに注意）
date1 = Date(2019, 12, 31) + 1
print(date1)            #=> 2020-01-01
print(type(date1))      #=> <class '__main__.Date'>
