import sys, re

def f(string):
    return _rexp.sub(_replace, string)

_rexp = re.compile(r'\{(\w+)\}')

def _replace(m):
    key = m.group(1)
    frame = sys._getframe(2)
    try:
        if key in frame.f_locals:   #<- ローカル変数を検索し
            return str(frame.f_locals[key])  #<- 置換する
        if key in frame.f_globals:  #<- グローバル変数を検索し
            return str(frame.f_globals[key])  #<- 置換する
        return "{%s}" % key         #<- なければ置換しない
    finally:
        del frame

## f%"..." でも使えるように改善

_f = f

class FString:
    __mod__  = staticmethod(_f)  #<- '%' 演算子を上書き
    __call__ = staticmethod(_f)  #<- f()でも呼び出せるように

f = FString()

## 使い方
w = 2560
h = 1600
print(f("width={w}, height={h}"))  #<- 関数呼び出しでの使い方
print(f%"width={w}, height={h}")   #<- よりf-文字列っぽい使い方
