## Pythonでは組み込みクラス「list」を変更できないので、
## かわりに「list」を継承したクラスを作る
class MyList(list):

    def __lshift__(self, arg):   #<- 「<<」に対応する特殊メソッド
        list.append(self, arg)   #<- 親クラスのメソッドを呼び出す

## 使い方
list1 = MyList(['A', 'B'])
list1 << 'C'     #<- list1.__lshift__('C') と同じ
list1 << 'D'     #<- list1.__lshift__('D') と同じ
print(list1)    #=> ['A', 'B', 'C', 'D']
