class MyList(list):

    def __lshift__(self, arg):   #<- 「<<」に対応する特殊メソッド
        list.append(self, arg)   #<- 親クラスのメソッドを呼び出す
        return self              #<- リスト自身を返す

    def __rrshift__(self, arg):  #<- 「>>」の左右入れ換え版
        list.append(self, arg)   #<- 親クラスのメソッドを呼び出す
        return self              #<- リスト自身を返す

## 使い方
list1 = MyList(['A', 'B'])
'C' >> list1
print(list1)    #=> ['A', 'B', 'C']
'F' >> ('E' >> ('D' >> list1)) #<- 連続して使うには丸カッコが必要（後述）
print(list1)    #=> ['A', 'B', 'C', 'D', 'E', 'F']
