class Point:
    """経路のポイント"""

    def __init__(self, name):
        self.name = name

class Route:
    """経路"""

    def __init__(self):
        self._points = []    #<- 順番に並んだ経路ポイント

    def __str__(self):
        return " > ".join( p.name for p in self._points )

    def append(self, point):  #<- 経路に追加する
        self._points.append(point)
        return self          #<- メソッドチェーンができるように

    @property
    def start_point(self):   #<- 経路の最初のポイント
        return self._points[0] if self._points else None

    @property
    def end_point(self):     #<- 経路の最後のポイント
        return self._points[-1] if self._points else None

## 使い方
新宿 = Point("新宿"); 代々木 = Point("代々木")
原宿 = Point("原宿"); 渋谷   = Point("渋谷")
route1 = Route().append(新宿).append(代々木).append(原宿).append(渋谷)
print(route1)
