from time import time

def bench(func):      #<- 関数デコレータ用の高階関数
    t1 = time()       #<- 前処理
    func()            #<- 関数を実行
    t2 = time()       #<- 後処理
    label = func.__doc__ or func.__name__
    print("%s: %.3f sec" % (label, t2 - t1))

## 使い方
def fib(n):           #<- フィボナッチ数列を計算する
    if n <= 1:
        return n
    else:
        return fib(n-1) + fib(n-2)

@bench                #<- 計測したい関数につけるだけ
def fibonacci_33():
    fib(33)

        #<- 関数を呼び出す必要はない
