import re

## クラス変数としてテーブル名を自動付与するクラスデコレータ
def table(cls):
    cls.table_name = classname2tablename(cls.__name__)
    return cls

## クラス名からテーブル名を生成する
## （単数系・複数形は考えない、大文字が連続した場合も考えない）
## 例：'SalesOrder' -> 'sales_order'
def classname2tablename(name):
    rexp = re.compile(r'([A-Z][^A-Z]*)')
    items = ( m.group(1).lower() for m in rexp.finditer(name) )
    return "_".join(items)

## 使用例
@table          #<- クラスデコレータ
class SalesOrder:
    ...

print(SalesOrder.table_name)   #=> sales_order
