def hello(cls):           #<- クラスを受け取る
    class newcls(cls):    #<- クラスを継承した新しいクラス
        def hello(self):  #<- hello()メソッドを定義
            print(f"Hello, {self.name}!")
    newcls.__name__ = cls.__name__
    newcls.__doc__  = cls.__doc__
    return newcls         #<- 新しいクラスを返す

@hello                    #<- クラスデコレータ
class Hello:              #<- hello()メソッドを持たないクラス
    def __init__(self, name):
        self.name = name

## hello()メソッドが使えることを確認
Hello("world").hello()   #=> Hello, world!
