## 高階関数
def debug(func):        #<- 引数に関数を受け取る
    def newfunc():      #<- 新しい関数を作成
        print(f"** {func.__name__}(): enter")   #<- 前処理
        func()          #<- もとの関数を呼び出す
        print(f"** {func.__name__}(): exit")    #<- 後処理
    return newfunc      #<- 作成した新しい関数を返す

## こんな関数があったとして、
def hello():            #<- 実質的には変数「hello」に関数を代入してる
    print("Hello, world!")

## さきほど定義した高階関数を使うと、前処理と後処理が追加される
hello = debug(hello)    #<- 変数「hello」に新しい関数を代入する
hello()                 #<- 変数「hello」に代入されている関数を呼び出す
