## 関数デコレータ用の高階関数
def debug(func):
    def newfunc(*args, **kwargs):  #<- 任意の引数に対応
        print(f"** {func.__name__}(): enter")
        ret = func(*args, **kwargs)   #<- 引数を渡して呼び出す
        print(f"** {func.__name__}(): exit")
        return ret         #<- 戻り値を返す
    return newfunc

## 関数デコレータを使用する
@debug
def hello(name="world"):   #<- 引数を取る
    print(f"Hello, {name}!")
    return True            #<- 戻り値を返す

ret = hello(name="Python")  #<- 引数を渡す
print(ret)                 #=> True
