## 関数デコレータ用の高階関数
def debug(default_name):   #<- 「関数を返す関数」を返す関数
    def deco(func):        #<- 関数を返す関数
        def newfunc(name=default_name):
            ret = func(name)
            return ret
        return newfunc     #<- 関数を返す
    return deco            #<- 「関数を返す関数」を返す

## 関数デコレータを使用する
@debug("world")            #<- nameのデフォルト値を指定
def hello(name):
    print(f"Hello, {name}!")

## 引数がないときは関数デコレータで指定したデフォルト値が使われる
hello("Python")            #=> Hello Python!
hello()                    #=> Hello world!
