from functools import wraps

## 関数デコレータ用の高階関数
def debug(func):
    @wraps(func)           #<- 関数名とDocstringをコピー
    def newfunc(*args, **kwargs):
        return func(*args, **kwargs)
    return newfunc

## 関数デコレータを使用する
@debug
def hello(name=):
    """あいさつを表示"""   #<- これがDocstring
    print(f"Hello, {name}!")

## 関数名とDocstringを表示する
print(hello.__name__)   #<- 「hello」と表示されてほしい
print(hello.__doc__)    #<- 「あいさつを表示」と表示されてほしい
