## このヘルパー関数を使えば
def call(*args, **kwargs):
    def deco(func):         #<- 関数デコレータ用の高階関数
        return func(*args, **kwargs)   #<- 関数を返さずに実行する
    return deco

## これが
def fn(x, y):
    result = (x + y) * (x - y)
    print(result)     #=> -300
fn(10, 20)

## こう書ける
@call(10, 20)         #<- 最初に実引数があるので見やすい
def fn(x, y):
    result = (x + y) * (x - y)
    print(result)     #=> -300

## ちなみにfnは関数の実行結果で置き換えられる
print(fn)             #=> None
