from functools import wraps
from django.http import HttpResponse, HttpResponseNotAllowed

def on(method):
    def deco(func):
        methods = ('GET', 'HEAD') if method == 'GET' \
                  else (method,)
        @wraps(func)
        def newfunc(request, **kwargs):
            if request.method in methods:
                return func(request, **kwargs)
            return HttpResponseNotAllowed(list(methods),
                            "<p>405 Method Not Allowed</p>\n")
        return newfunc
    return deco

## 使い方
@on('GET')
def index(request):
    return HttpResponse("<p>Hello, GET!</p>\n")
