from functools import wraps

def deco(func):
    @wraps(func)
    def newfunc(*args, **kwargs):
        return func(*args, **kwargs)
    return newfunc

@deco
def hello(name):
    print(f"Hello, {name}!")

print(hello)                      #<- 新しい関数
print(hello.__code__.co_varnames) #=> ('ars', 'kwargs')
print(hello.__code__.co_argcount) #=> 0

print(hello.__wrapped__)          #<- もとの関数
print(hello.__wrapped__.__code__.co_varnames) #=> ('name',)
print(hello.__wrapped__.__code__.co_argcount) #=> 1
