def outer1(buf):
    ## これはクロージャ
    def inner1(seq):
        for i in seq:
            buf.append(i)  #<- buf は外側のローカル変数
    return inner1

def outer2(buf):
    ## これはクロージャではない
    def inner2(seq, buf=buf): #<- 引数のデフォルト値に指定
        for i in seq:
            buf.append(i)  #<- buf は内側のローカル変数
    return inner2

inner1 = outer1([])
print(inner1.__closure__)  #=> (<cell>,)

inner2 = outer2([])
print(inner2.__closure__)  #=> None

from time import time
n = 1000000
print()

seq1 = range(n)
t1 = time()
inner1(seq1)    #<- クロージャなので少し遅い
print("func1: %.3f sec" % (time() - t1))

seq2 = range(n)
t2 = time()
inner2(seq2)    #<- クロージャではないので少し速い
print("func2: %.3f sec" % (time() - t2))
