## aとbとcが位置引数（うちaとbは位置専用引数）、dとeがキーワード専用引数
def f4(a, b=1, /, c=[], *, d, e={}):
    pass

n1 = f4.__code__.co_argcount  #<- 位置引数の数（位置専用引数も含む）
n2 = f4.__code__.co_kwonlyargcount  #<- キーワード専用引数の数
argnames = f4.__code__.co_varnames[:n1+n2] #<- 引数の名前

n3 = len(f4.__defaults__)       #<- 引数のある位置引数の数
print(argnames[0:n1-n3])        #<- デフォルト値のない引数名
print(argnames[n1-n3:n1])       #<- デフォルト値のある引数名

kwonlynames = argnames[n1:]     #<- キーワード専用引数の名前
keys1 = f4.__kwdefaults__.keys()      #<- デフォルト値のある引数名
keys2 = set(kwonlynames) - set(keys1) #<- デフォルト値のない引数名
print(tuple(keys2))    #=> ('d',)
print(tuple(keys1))    #=> ('e',)
