from time import time

def runfib1(x):  ## クロージャを使う
    def fib1(n):
        if n <= 1: return n
        return fib1(n-1) + fib1(n-2)
    return fib1(x)

def runfib2(x):  ## デフォルト値を変更して通常の関数に
    def fib2(n, fib2=None):
        if n <= 1: return n
        return fib2(n-1) + fib2(n-2)
    fib2.__defaults__ = (fib2,)
    return fib2(x)

def runfib3(x):  ## リストを使って通常の関数に
    arr = [None]
    def fib3(n, arr=arr):
        if n <= 1: return n
        fib3 = arr[0]
        return fib3(n-1) + fib3(n-2)
    arr[0] = fib3
    return fib3(x)

def runfib4(x):  ## グローバルな関数
    return fib4(x)
def fib4(n):
    if n <= 1: return n
    return fib4(n-1) + fib4(n-2)

N = 34
for fn in [runfib1, runfib2, runfib3, runfib4]:
    t1 = time()
    v  = fn(N)
    t2 = time()
    print("%s(%s) = %s (%.3fs)" % (fn.__name__, N, v, t2 - t1))
