import re

class Hello(object):           #<- 親クラス

    def __new__(cls, name):
        ## 名前がアルファベットか判定し、子クラスのオブジェクトを生成する
        if re.match(r'^[a-zA-Z0-9 ]+$', name):
            return super().__new__(EnglishHello)  #<- 英語用
        else:
            return super().__new__(JapaneseHello) #<- 日本語用

    def __init__(self, name):
        self.name = name

class EnglishHello(Hello):     #<- 子クラス（英語用）
    def hello(self):
        print(f"Hello, {self.name}!")

class JapaneseHello(Hello):    #<- 子クラス（日本語用）
    def hello(self):
        print(f"こんにちは、{self.name}！")

## 名前がアルファベット
obj1 = Hello("world")
print(type(obj1))     #=> <class '__main__.EnglishHello'>
obj1.hello()          #=> Hello, world!

## 名前がアルファベット以外
obj2 = Hello("世界")
print(type(obj2))     #=> <class '__main__.JapaneseHello'>
obj2.hello()          #=> こんにちは、世界！
