class HelloA:            #<- 親クラス
    def hello(self):
       return "Hello, world"

class HelloB(HelloA):    #<- 子クラス
    def hello(self):
        s = super().hello() #<- __class__は使ってないけどsuper()はある
        return s + "!!"  #<- 戻り値に「!!」を足す

## 親クラスのhello()はsuper()を使ってないのでクロージャではない
print(HelloA.hello.__closure__)  #=> None

## 子クラスのhello()はsuper()を使っているのでクロージャになる
print(HelloB.hello.__closure__)
    #=> (<cell at 0x105fd4070: type object at 0x7fdd8bf04fc0>,)
print(HelloB.hello.__closure__[0].cell_contents)
    #=> <class '__main__.HelloB'>
