domain = "example.com"

class APIClient:

    def __init__(self, api_ver):
        self.api_ver = api_ver
        self._base_url = None  #<- キャッシュ用のインスタンス変数

    @property
    def base_url(self):
        if self._base_url is None:  #<- ベースURLが未設定なら設定
            self._base_url =  f"https://{domain}/api/v{self.api_ver}"
        return self._base_url  #<- ベースURLを返す

client = APIClient(2)
print(client.base_url)   #=> https://example.com/api/v2
print(client._base_url)  #<- インスタンス変数にキャッシュされている
