class Hello:

    @classmethod
    def hello(cls, name):        #<- クラスメソッド
        print(f"Hello, {name}!")

    ## クラスメソッドオブジェクトには__get__()がある
    print(type(hello))     #=> <class 'classmethod'>
    print(hello.__get__)   #=> <method-wrapper '__get__' of classmethod object...>

## クラスメソッドを実行
Hello.hello("world")       #=> Hello, world!

## これは次のように分解できる
method = Hello.hello       #<- hello.__get__()が実行される
print(type(method))        #=> <class 'method'>
method("world")            #=> Hello, world!

## さらに分解できる
method = Hello.__dict__['hello'].__get__(None, Hello)
print(type(method))        #=> <class 'method'>
method("world")            #=> Hello, world!
