class Hello:
    def __init__(self, name):
        self.name = name

    ## __get__()があるので、Helloクラスのインスタンスオブジェクトは
    ## ディスクリプタとして扱われる。
    def __get__(self, *args):
        return f"Hello, {self.name}!"

class Dummy:

    ## クラス変数にHelloオブジェクトを設定
    attr1 = Hello("world")  #<- ディスクリプタ

## オブジェクトのattr1属性にアクセスすると、
## Helloオブジェクトが返されるかと思いきや、
## Helloオブジェクトの__get__()が実行される。
print(Dummy().attr1)    #=> Hello, world!
print(Dummy.attr1)      #=> Hello, world!
