class Hello:

    def __get__(self, obj, klass):
        return f"Hello, {obj.name}!"

    def __set__(self, obj, value):
        obj.name = value

    def __delete__(self, obj): #<- 「del obj.attr1」のときに実行される
        print(obj)
        obj.name = None

class Dummy:

    def __init__(self, name):
        self.name = name

    attr1 = Hello()

## インスタンスオブジェクトの属性attr1を設定する
obj = Dummy("world")
print(obj.name)   #=> world
del obj.attr1     #<- attr1.__delete__(obj) が実行される
print(obj.name)   #=> None
