class Hello:

    @staticmethod
    def hello():          #<- staitcメソッド（selfがないことに注意）
        print("Hello, world!")

    print(type(hello))    #=> <class 'staticmethod'>

## インスタンスからもクラスからも呼び出せる。
Hello().hello()    #=> Hello, world!
Hello.hello()      #=> Hello, world!

## これは次のように分解できる
## （__get__()の戻り値がメソッドオブジェクトでないことに注意）
func = Hello.hello #<- hello.__get__()が呼び出される
print(type(func))  #=> <class 'function'>
func()             #=> Hello, world!

## さらに分解するとこうなる
func = Hello.__dict__['hello'].__get__(None, Hello)
print(type(func))  #=> <class 'function'>
func()             #=> Hello, world!
