class MyMetaclass(type):
    def __init__(self, name, bases, dict_):
        type.__init__(self, name, bases, dict_)
        ## コールバック関数があれば、クラスオブジェクトを引数にして実行
        func = dict_.get('__init_thisclass__')
        if func is not None:
            func(self)

class Object(object, metaclass=MyMetaclass):
    pass

class Status(Object):

    def __init__(self, name):
        self.name = name

    def __repr__(self):
        return "Status(%r)" % self.name

    ## こうしたいけど、Pythonではできない
    #ACTIVE    = Status("Active")
    #SUSPENDED = Status("Suspended")

    ## かわりに、クラス定義後に実行されるコールバック関数を用意する
    def __init_thisclass__(cls):
        cls.ACTIVE    = cls("Active")
        cls.SUSPENDED = cls("Suspended")

print(Status.ACTIVE)     #=> Status('Active')
print(Status.SUSPENDED)  #=> Status('Suspended')
