## メタクラス
class MyMetaclass(type):  #<- 「type」を継承する

    ## クラスオブジェクトを初期化する
    ## （第1引数の「self」はクラスオブジェクト）
    def __init__(self, name, bases, dict_):
        ## 親クラスの初期化メソッドを呼び出す
        type.__init__(self, name, bases, dict_)
        ## クラスオブジェクトを操作する
        ## （例：インスタンスメソッドを追加する）
        def hello(self):
            print(f"Hello, {self.name}!")
        self.hello = hello

## 通常のクラス
## （インスタンスメソッドが定義されていないことに注意）
class Hello(object, metaclass=MyMetaclass): #<- メタクラスを指定

    def __init__(self, name):
        self.name = name

## 定義されていないはずのインスタンスメソッドを呼び出す
obj = Hello("world")
obj.hello()             #=> Hello, world!
