## メタクラス
class MyMetaclass(type):  #<- 「type」を継承する


    ## クラスオブジェクトを生成する
    def __new__(cls, name, bases, dict_):
        ## クラスオブジェクト用の辞書を操作する
        ## （例：インスタンスメソッドを追加する）
        def hello(self):
            print(f"Hello, {self.name}!")
        dict_['hello'] = hello
        ## 親クラスのメソッドを呼び出す
        return type.__new__(cls, name, bases, dict_)

## 通常のクラス
## （インスタンスメソッドが定義されていないことに注意）
class Hello(object, metaclass=MyMetaclass): #<- メタクラスを指定

    def __init__(self, name):
        self.name = name

## 定義されていないはずのインスタンスメソッドを呼び出す
obj = Hello("world")
obj.hello()             #=> Hello, world!
