## 「__init__()」を使うと「__slots__」の指定が効かない
class Meta1(type):
    def __init__(cls, name, bases, dict_):
        dict_['__slots__'] = ('name',)      #<- 効かない
        type.__init__(cls, name, bases, dict_)
        cls.__slots__ = ('name',)           #<- 効かない

class Hello1(object, metaclass=Meta1):
    def __init__(self, name):
        self.name = name

print(Hello1("world").__dict__)  #=> {'name': 'world'}
print()

## 「__new__()」を使うと「__slots__」の指定が効く
class Meta2(type):
    def __new__(cls, name, bases, dict_):
        dict_['__slots__'] = ('name',)      #<- 効く
        return type.__new__(cls, name, bases, dict_)

class Hello2(object, metaclass=Meta2):
    def __init__(self, name):
        self.name = name

print(Hello2("world").__dict__)  #=> AttributeError
