class MyMetaclass(type):
    ## クラスオブジェクトを操作しないなら、__init__()は必要ない
    #def __init__(self, name, bases, dict_):
    #    type.__init__(self, name, bases, dict_)

    ## 本来の意味でのクラスメソッド
    def hello(cls, name):
        print(f"HELLO, {name.upper()}!")

class Hello(object, metaclass=MyMetaclass):
    pass

## クラスオブジェクトの辞書には 'hello' がない
print(Hello.__dict__.get('hello'))  #=> None

## クラスメソッドを呼び出す
Hello.hello("world")    #=> HELLO, WORLD!
