## クラスデコレータ
def myclassdeco(cls):      #<- クラスオブジェクトを受け取り、
    def hello(self):
        print(f"Hello, {self.name}!")
    cls.hello = hello      #<- インスタンスメソッドを追加し、
    return cls             #<- クラスオブジェクトを返す

@myclassdeco               #<- クラスデコレータ
class Hello(object):
    def __init__(self, name):
        self.name = name

## インスタンスメソッドが追加されていることを確認
print(Hello.hello)    #=> <function myclassdeco.<locals>.hello>

## 使用例
obj = Hello("world")
obj.hello()           #=> Hello, world!
