##....省略....
import re

## クラス名からテーブル名を生成する（簡単化のため連続した大文字は考慮せず）
## 例：'SalesOrder' -> 'sales_order'
def classname2tablename(name):
    rexp = re.compile(r'([A-Z][^A-Z]*)')
    items = ( m.group(1).lower() for m in rexp.finditer(name) )
    return "_".join(items)

## メタクラス
class TableMetaclass(type):
    def __init__(self, name, bases, dict_):
        type.__init__(self, name, bases, dict_)
        ## テーブル名を自動設定する（ただしTableクラスを除く）
        if name != 'Table':  #<- または if bases[0] is not object:
            self.table_name = classname2tablename(name)

##....省略....

## テーブルのカラム情報
class Column(object):
    def __init__(self, name, type, *, pk=False, notnull=False):
        self.name    = name     #<- カラム名
        self.type    = type     #<- データ型
        self.pk      = pk       #<- 主キー(primary key)制約
        self.notnull = notnull  #<- not null制約
        if pk:
            self.notnull = True #<- 主キーなら自動的にnot nullにする

## テーブルクラス（他のクラスの親クラス）
class Table(object, metaclass=TableMetaclass):
    pass

## 受注クラス（sales_orderテーブルに対応）
class SalesOrder(Table):
    id        = Column('id'        , int, pk=True)
    item      = Column('item'      , str)
    count     = Column('count'     , int)
    unitprice = Column('unitprice' , int)

## 管理者ユーザステータスクラス（admin_user_statusテーブルに対応）
class AdminUserStatus(Table):
    code      = Column('code'      , str, pk=True)
    name      = Column('name'      , str)
    desc      = Column('count'     , str, notnull=False)
