class Cache

  def initialize
    @cache = {}
  end

  ## データがキャッシュされていればそれを返し、
  ## されてなければキャッシュに設定して返す。
  def get(key, &block)
    if @cache.key?(key)        #<- キャッシュされているか？
      return @cache[key]       #<- キャッシュデータを取得
    else
      val = block.call()       #<- ブロック引数を実行
      @cache[key] = val        #<- キャッシュデータを設定
      return val
    end
  end

end

## 使用例
cache = Cache.new
print cache.get("key1") {         #<- 「{」から
  buf = []
  buf << "<ul>\n"
  (1..3).each do |i|
    buf << "  <li>#{i}</li>\n"
  end
  buf << "</ul>\n"
  buf.join("\n")
}                                #<- 「}」までがブロック引数
