class Cache:

    _data = {}   #<- クラス変数

    def __call__(self, key): #<- 関数のような呼び出しを可能に
        if key in self._data:            #<- 前処理
            self.value = self._data[key] #<- 前処理
        else:
            buf = []
            yield buf                    #<- 本処理（引数つき）
            self.value = self._data[key] = "".join(buf) #<- 後処理

## 使い方
## （Pythonのfor文は値を返さないので、かわりにコールバック関数を使う）
cache = Cache()
for buf in cache("key1"):
    buf.append("<ul>\n")
    for i in range(1, 4):
        buf.append(f"  <i>{i}</li>\n")
    buf.append("</ul>")
print(cache.value)
