def traverse(items):
    """入れ子になったリストの要素にアクセスする"""
    for x in items:
        if isinstance(x, list):
            yield from traverse(x)
        else:
            yield x

## 入れ子になったリストをfor文でループできる
nested_list = [10, 20, [30, [40, 50, [60]]], 70]
for x in traverse(nested_list):
    print(x)
