import os
from random import randint
from contextlib import contextmanager

@contextmanager
def tmpfile(content, encoding='utf-8'):
    ## 前処理：一時ファイルを作成
    filename = "tmp.%03d" % randint(1, 999) #<- ローカル変数を設定
    with open(filename, 'w', encoding=encoding) as f: #<- 引数を参照
        f.write(content)                         #<- 引数を参照
    ## 本処理
    try:
        yield filename
    ## 後処理：一時ファイルを削除
    finally:
        if os.path.exists(filename):       #<- ローカル変数を参照
            os.unlink(filename)            #<- ローカル変数を参照

## 使用例
with tmpfile("Hello") as filename:
    print(open(filename).read())
