import os
from random import randint

class tmpfile:

    def __init__(self, content, encoding='utf-8'):
        self.content = content    #<- 引数をインスタンス変数に設定
        self.encoding = encoding  #<- 引数をインスタンス変数に設定

    def __enter__(self):
        ## 前処理
        self._filename = "tmp.%03d" % randint(1, 999) #<- インスタンス変数を設定
        with open(self._filename, 'w', encoding=self.encoding) as f: #<- 引数をインスタンス変数経由で参照
            f.write(self.content) #<- 引数をインスタンス変数経由で参照
        return self._filename

    def __exit__(self, *args):
        ## 後処理
        if os.path.exists(self._filename): #<- インスタンス変数を参照
            os.unlink(self._filename)      #<- インスタンス変数を参照

## 使用例
with tmpfile("Hello") as filename:
    print(open(filename).read())
