class ExampleContext:

    def __init__(self, value):
        self.value = value

    def __enter__(self):
        print("** __enter__()")
        return self.value  #<- 戻り値が「with ... as x」のxに入る

    def __exit__(self, *args):
        print("** __exit__%r" % (args,))

## 使用例（例外が発生しない場合）
with ExampleContext(123) as x:
    print(f"x={x}")
