from contextlib import contextmanager

@contextmanager
def f1(value):
    print("** enter")       #<- 前処理
    try:
        yield value         #<- with文のブロックが実行される
    finally:
        print("** exit")    #<- 後処理

## with文のブロックで例外が発生しても、後処理が実行される
with f1(123) as x:
    x.foobar()              #=> AttributeError
