import sys
from traceback import format_exception

def excepthook(exc_type, exc, exc_traceback):
    exc_type = type(exc)               #<- 引数を使わない
    exc_traceback = exc.__traceback__  #<- 引数を使わない
    items = format_exception(exc_type, exc, exc_traceback)
    sys.stderr.write("".join(items))
sys.excepthook = excepthook  #<- デフォルトの例外ハンドラとして設定

def f1(): f2()
def f2(): f3()
def f3(): blabla()  #=> NameError: name 'blabla' is not defined

try:
    f1()
except NameError as ex:
    tb = ex.__traceback__
    ex.__traceback__ = tb.tb_next.tb_next.tb_next  #<- 2つスキップ
    raise
