import os
import json

filename = "ex-jsonerror.json"
try:
    with open(filename) as f:
        json_data = json.load(f)
except json.decoder.JSONDecodeError as ex:
    ## jsonモジュールのトレースバックは表示しない
    pylibpath = os.path.dirname(json.__file__)
    tb = ex.__traceback__
    while tb.tb_next is not None:
        pyfile = tb.tb_next.tb_frame.f_code.co_filename
        if pyfile.startswith(pylibpath):
            tb.tb_next = tb.tb_next.tb_next
        else:
            tb = tb.tb_next
    raise     #<- 同じ例外を再送する
