import sys
import testcase
__skipTraceback = True

class TestRunner:         #<- テストランナー

    def run(self):
        ## TestCaseクラスの子クラスをインスタンス化して実行する
        for cls in testcase.TestCase.__subclasses__():
            for name in dir(cls):
                if name.startswith('test'):
                    self._run(cls, name)

    def _run(self, cls, name):
        result = 'ok'; ex = None
        try:
            cls().run(name)   #<- インスタンス化して実行
        except AssertionError as _ex:  #<- アサーション例外
            result = 'Fail'; ex = _ex
        except Exception as _ex:       #<- それ以外の例外
            result = 'Error'; ex = _ex
        print(f"- [{result}] {cls.__name__}.{name}()")
        if ex:   #<- 例外があればトレースバックを表示
            sys.excepthook(type(ex), ex, ex.__traceback__)

def main():
    TestRunner().run()
