class BaseTemplate:               #<- コア機能その1
    def render(self, context):
        ...
    def escape(self, value):
        ...

class HTMLTemplate(BaseTemplate): #<- コア機能その2
    def escape(self, value):
        ...

def _dummy(__name__):           #<- __name__ はモジュール名を表す
    def template_debugger(template):  #<- デバッグ用関数その1
        ...
    def context_printer(context):     #<- デバッグ用関数その2
        ...
    return locals()             #<- ローカル変数の一覧を辞書で返す

import sys
mod = type(sys)(__name__ + ".debug")  #<- モジュールオブジェクトを作成
mod.__dict__.update(_dummy(mod.__name__)) #<- モジュールに関数を追加
sys.modules[mod.__name__] = mod       #<- モジュールを登録
del mod, _dummy
from mytemplate import debug          #<- インポートできることを確認
